package cn.gov.customs.data.config;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.data.jpa.repository.config.EnableJpaRepositories;
import org.springframework.orm.jpa.JpaTransactionManager;
import org.springframework.orm.jpa.LocalContainerEntityManagerFactoryBean;
import org.springframework.orm.jpa.vendor.Database;
import org.springframework.orm.jpa.vendor.HibernateJpaVendorAdapter;
import org.springframework.transaction.PlatformTransactionManager;
import org.springframework.transaction.annotation.EnableTransactionManagement;

import javax.sql.DataSource;

/**
 * transactionManagerRef 事务管理工厂引用名称，对应到@Bean注解对应的方法
 * entityManagerFactoryRef 实体管理工厂引用名称，对应到@Bean注解对应的方法
 */

@Configuration
@EnableTransactionManagement
@EnableJpaRepositories(
        entityManagerFactoryRef="entityManagerIedg",
        transactionManagerRef="transactionManagerIedg",
        basePackages= {"cn.gov.customs.data.repository.iedg"}) //设置Repository所在位置  dao 文件的路径
public class IedgConfig {

    @Autowired
    @Qualifier("iedgDataSource")
    private DataSource iedgDataSource;


    @Bean
    PlatformTransactionManager transactionManagerIedg() {
        return new JpaTransactionManager(entityManagerIedg().getObject());
    }

    @Bean
    public LocalContainerEntityManagerFactoryBean entityManagerIedg() {
        HibernateJpaVendorAdapter vendorAdapter = new HibernateJpaVendorAdapter();
        vendorAdapter.setDatabase(Database.ORACLE);
        vendorAdapter.setShowSql(true);

        LocalContainerEntityManagerFactoryBean factoryBean = new LocalContainerEntityManagerFactoryBean();
        factoryBean.setDataSource(iedgDataSource);
        factoryBean.setJpaVendorAdapter(vendorAdapter);
        factoryBean.setPackagesToScan("cn.gov.customs.data.entity.iedg*"); //jpa对应的实体的位置
        return factoryBean;
    }
}
